package com.zillion.database.second.impl;

import java.util.regex.Pattern;

import com.alibaba.fastjson.JSONObject;
import com.zillion.database.second.ISecondComparable;
import com.zillion.database.second.SecondAnnotation;

@SecondAnnotation(value = "dao_data")
public class ComparableImpl_regex implements ISecondComparable {
	String column;
	String param;
	Pattern pattern;

	public static String Name() {
		return "$regex";
	}

	public void setColumn(String column) {
		this.column = column;
	}

	public void setParam(Object param) {
		this.param = (String) param;
		this.pattern = Pattern.compile(this.param);
	}

	public boolean match(JSONObject jsonObject) throws Exception {
		Object columnValue = jsonObject.get(this.column);
		if (columnValue == null) {
			return false;
		} else {
			return this.pattern.matcher((String) columnValue).matches();
		}
	}
}
