package com.zillion.database.util;

public class TableWrapper_MySQL implements ITableWrapper {
	public int connection_index;
	int using_count = 0;
	public String tableName;

	public TableWrapper_MySQL(int index, String tableName) {
		this.connection_index = index;
		this.tableName = tableName;
	}

	public synchronized boolean can_use() {
		if (this.using_count < 1) {
			return true;
		} else {
			return false;
		}
	}

	public synchronized void use() {
		this.using_count++;
	}

	public synchronized void unuse() {
		this.using_count--;
	}

	public void close() {
	}
}
