package com.zillion.util.common;

import org.apache.zookeeper.data.Stat;
import org.zillion.util.log.LogUtil;

import com.zillion.util.zk.ZKWrapper;

public class ZKRepositoryUtil {
	public static int ResetRepoVersion(ZKWrapper zookeeper, String namespace, String parent_path_table, String lock_type_table) throws Exception {
		int repo_version_new;
		String zkpath_namespace = ZillionConstant.zk_root + ZillionConstant._ns + "/" + namespace;
		Stat stat = new Stat();
		zookeeper.getData(zkpath_namespace + ZillionConstant.zk_tablelocks, false, stat);
		int repo_version_old = stat.getVersion();
		if (lock_type_table.equals("c") || lock_type_table.equals("e")) {
			zookeeper.setData(parent_path_table, "c".getBytes("UTF-8"), -1);
			zookeeper.setData(zkpath_namespace + ZillionConstant.zk_tablelocks, "true".getBytes("UTF-8"), -1);
		} else if (lock_type_table.equals("d")) {
			zookeeper.setData(parent_path_table, lock_type_table.getBytes("UTF-8"), -1);
			zookeeper.setData(zkpath_namespace + ZillionConstant.zk_tablelocks, "true".getBytes("UTF-8"), -1);
		}
		zookeeper.getData(zkpath_namespace + ZillionConstant.zk_tablelocks, false, stat);
		repo_version_new = stat.getVersion();
		LogUtil.warn(" ********************************** " + namespace + " old version: " + repo_version_old + " new version: " + repo_version_new);
		return repo_version_new;
	}
}
