package com.zillion.util.table;

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.HTable;

import com.zillion.database.util.TableWrapper_HBase;
import com.zillion.util.common.ZillionConstant;

public class HBaseConnectionWrapper {
	Configuration configuration;
	Connection connection;

	public HBaseConnectionWrapper(Configuration configuration) {
		this.configuration = configuration;
	}

	public synchronized void InitializeConnection(Connection connection) {
		this.connection = connection;
	}

	public synchronized TableWrapper_HBase getTable(int exist_count, TableName TableName) throws IOException {
		HTable table = (HTable) this.connection.getTable(TableName);
		if (ZillionConstant.disable_AutoFlush) {
			table.setAutoFlush(false, true);
		}
		TableWrapper_HBase wrapper = new TableWrapper_HBase(exist_count, table);
		return wrapper;
	}
}
