package com.zillion.util.zk;

import org.apache.zookeeper.WatchedEvent;
import org.apache.zookeeper.Watcher;
import org.apache.zookeeper.Watcher.Event.EventType;

public class ZKLockWatcher implements Watcher {
	ZKLockSingal singal;

	public ZKLockWatcher(ZKLockSingal singal) {
		this.singal = singal;
	}

	public void process(WatchedEvent event) {
		if (event.getType() == EventType.NodeDeleted) {
			this.singal.deleted = true;
		}
	}
}
