package org.zillion.util.json;

import com.sagacloud.json.JSONArray;
import com.sagacloud.json.JSONObject;

public class JSONArrayUtil {
	private static JSONArrayUtil instance = new JSONArrayUtil();

	public static JSONArrayUtil Instance() {
		return instance;
	}

	private JSONArrayUtil() {

	}

	public Object GetChildField(JSONArray array, String propertyName, String propertyValue, String targetName) {
		for (int i = 0; i < array.size(); i++) {
			JSONObject item = (JSONObject) array.get(i);
			String itemName = (String) item.get(propertyName);
			if (itemName.equals(propertyValue)) {
				return item.get(targetName);
			}
		}
		return null;
	}

	public JSONObject GetChild(JSONArray array, String propertyName1, String propertyValue1) {
		for (int i = 0; i < array.size(); i++) {
			JSONObject item = (JSONObject) array.get(i);
			String itemValue1 = (String) item.get(propertyName1);
			if (itemValue1.equals(propertyValue1)) {
				return item;
			}
		}
		return null;
	}

	public JSONObject Get(JSONArray array, String propertyName1, String propertyValue1) {
		for (int i = 0; i < array.size(); i++) {
			JSONObject item = (JSONObject) array.get(i);
			String itemValue1 = (String) item.get(propertyName1);
			if (itemValue1.equals(propertyValue1)) {
				return item;
			}
		}
		return null;
	}

	public JSONObject Get(JSONArray array, String propertyName1, String propertyValue1, String propertyName2, String propertyValue2) {
		for (int i = 0; i < array.size(); i++) {
			JSONObject item = (JSONObject) array.get(i);
			String itemValue1 = (String) item.get(propertyName1);
			String itemValue2 = (String) item.get(propertyName2);
			if (itemValue1.equals(propertyValue1) && itemValue2.equals(propertyValue2)) {
				return item;
			}
		}
		return null;
	}

	public JSONObject Get(JSONArray array, String propertyName1, String propertyValue1, String propertyName2, String propertyValue2,
			String propertyName3, String propertyValue3) {
		for (int i = 0; i < array.size(); i++) {
			JSONObject item = (JSONObject) array.get(i);
			String itemValue1 = (String) item.get(propertyName1);
			String itemValue2 = (String) item.get(propertyName2);
			String itemValue3 = (String) item.get(propertyName3);
			if (itemValue1.equals(propertyValue1) && itemValue2.equals(propertyValue2) && itemValue3.equals(propertyValue3)) {
				return item;
			}
		}
		return null;
	}
}
