package org.zillion.util.rand;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;

public class RandUtil {
	private static RandUtil instance = new RandUtil();

	public static RandUtil Instance() {
		return instance;
	}

	private RandUtil() {
		try {
			this.startDate = SIMPLEDATEFORMAT.parse("2000-01-01 00:00:00");
		} catch (ParseException e) {
			e.printStackTrace();
		}
	}

	SimpleDateFormat SIMPLEDATEFORMAT = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	Date startDate;

	public String nextName(Random random, int length) {
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < length; i++) {
			sb.append((char) ('a' + random.nextInt(26)));
		}
		return sb.toString();
	}

	public String nextTime(Random random) {
		Date date = new Date(this.startDate.getTime() + random.nextLong() % (1000L * 60 * 60 * 24 * 365));
		return SIMPLEDATEFORMAT.format(date);
	}
}
