package org.zillion.util.set;

import java.util.List;

public interface Map<K, V> {

	public boolean containsKey(Object key);

	public V get(Object key);

	public V put(K key, V value);
	
	public void clear();

	public List<K> keySet();

	public void remove(K key);

	public int size();
}
