import org.apache.hadoop.conf.Configuration;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class AgentTest_dropdatabase {

	public static void main(String[] args) throws Exception {
		// Configuration configuration = HBaseConfiguration.create();
		Configuration configuration = new Configuration();
		configuration.set("hbase.cluster.distributed", "true");
		configuration.set("hbase.zookeeper.quorum", "zookeeper1");
		ZillionAgent agent = new ZillionAgent(configuration);
		try {
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace();
		}

		String database_name = "database_1";
		String table_name = "originaldata0";
		JSONObject Criteria = (JSONObject) JSON.parse("{}");

		// JSONObject wrapperObject = new JSONObject();
		// wrapperObject.put("QueryType", "select_count");
		// wrapperObject.put("Criteria", Criteria);
		// wrapperObject.put("Database", database_name);
		// wrapperObject.put("Datatable", table_name);
		// JSONObject queryResult = agent.Query(wrapperObject);
		// long resultCount = (Long) queryResult.get("Count");
		// System.out.println(resultCount);

		String namespace = "database_1";
		System.out.println(agent.DDL_DropTable("database_1", "datatable_1"));
		// System.out.println(agent.NDL_DropDatabase(namespace));

		agent.Stop();
		System.out.println();
	}

}
