import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import java.util.Stack;

import org.zillion.util.json.Convertor_JSON;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

public class TestBig {
	class item {
		int i;
		double value;
	}

	static Random rand = new Random();

	static double digui(int i) {
		if (i <= 0) {
			return rand.nextDouble();
		} else {
			return digui(i - 1) + 1;
		}
	}

	static double digui_youhua(int i) {
		Stack<Integer> stack = new Stack<Integer>();
		stack.push(i);
		if (i <= 0) {
			return rand.nextDouble();
		} else {
			return digui(i - 1) + 1;
		}
	}

	public static void main(String[] args) throws Exception {
		{
			int a = Integer.MAX_VALUE - 1;
			int b = Integer.MAX_VALUE - 2;
			System.out.println(a + "\t" + b);
			a = a ^ b;
			b = a ^ b;
			a = a ^ b;
			System.out.println(a + "\t" + b);
			DecimalFormat df = new DecimalFormat("#.##");
			System.out.println(df.format(100.022));
		}
		{
			int a = Integer.MAX_VALUE - 1;
			int b = Integer.MAX_VALUE - 2;
			System.out.println(a + "\t" + b);
			a = a + b;
			b = a - b;
			a = a - b;
			System.out.println(a + "\t" + b);
		}
		{
			System.out.println(digui(100));
			System.out.println(digui(1000));
			System.out.println(digui(1023));
			System.out.println(digui(1024));
			System.out.println(digui(1025));
			System.out.println(digui(2048));
			System.out.println(digui(4096));
			System.out.println(digui(20000));
		}

		JSONObject aa = new JSONObject();
		aa.put("a", 1);
		aa.put("b", null);
		JSONArray bb = new JSONArray();
		bb.add(aa);
		JSONObject cc = new JSONObject();
		cc.put("cc", bb);
		System.out.println(bb.toJSONString());
		com.sagacloud.json.JSONObject aaa = (com.sagacloud.json.JSONObject) Convertor_JSON.FastJson2SagaJson(aa);
		com.sagacloud.json.JSONArray bbb = (com.sagacloud.json.JSONArray) Convertor_JSON.FastJson2SagaJson(bb);
		com.sagacloud.json.JSONObject ccc = (com.sagacloud.json.JSONObject) Convertor_JSON.FastJson2SagaJson(cc);
		System.out.println(aaa.toJSONString());
		System.out.println(bbb.toJSONString());
		System.out.println(ccc.toJSONString());
		for (int x = 1; x < 500; x++)
			for (int i = 1;; i++) {
				BBBBB b = divide(x, i);
				String ss = b.toString2();
				if (ss.contains("2018")) {
					System.out.println(x + "\t" + i + "\t" + b.toString());
					// System.out.println(b.toString2());
					break;
				}
			}
	}

	public static BBBBB divide(int x, int y) {
		List<Integer> yushuList = new ArrayList<Integer>();

		BBBBB result = new BBBBB();
		result.zheng = x / y;
		int tmp = x % y;
		while (true) {
			tmp *= 10;
			int t1 = tmp / y;
			int t2 = tmp % y;
			for (int i = 0; i < yushuList.size(); i++) {
				int yushu = yushuList.get(i);
				if (t2 == yushu) {
					result.index = i;
					break;
				}
			}
			if (result.index != -1) {
				break;
			}
			result.xiaoshuList.add(t1);
			yushuList.add(t2);
			tmp = t2;

			if (tmp == 0) {
				break;
			}
		}
		return result;
	}

}

class BBBBB {
	public int zheng;
	List<Integer> xiaoshuList = new ArrayList<Integer>();
	int index = -1;

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(zheng);
		sb.append(".");
		if (index == -1) {
			for (int i = 0; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
		} else {
			for (int i = 0; i < index; i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
			sb.append("(");
			for (int i = index; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
			sb.append(")");
		}
		return sb.toString();
	}

	public String toString2() {
		StringBuffer sb = new StringBuffer();
		sb.append(zheng);
		sb.append(".");
		if (index == -1) {
			for (int i = 0; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
		} else {
			for (int i = 0; i < index; i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
			for (int i = index; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
			for (int i = index; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
		}
		return sb.toString();
	}
}