package test.compress;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class Thread_zip_select extends Thread {
	ZillionAgent agent;
	String Database;
	String Datatable;

	public Thread_zip_select(ZillionAgent agent, String Database, String Datatable) {
		this.agent = agent;
		this.Database = Database;
		this.Datatable = Datatable;
	}

	public void run() {
		while (true) {
			String job = AgentTest_zip.Pop_select();
			if (job == null) {
				break;
			}

			try {
				Process(job);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	void Process(String order_id) throws Exception {
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "select");
		wrapperObject.put("Database", Database);
		wrapperObject.put("Datatable", Datatable);
		JSONObject Criteria = new JSONObject();
		Criteria.put("order_id", order_id);
		wrapperObject.put("Criteria", Criteria);
		JSONObject queryResult = agent.Query(wrapperObject);
		JSONArray Content = (JSONArray) queryResult.get("Content");
		JSONObject ContentItem = (JSONObject) Content.get(0);
		AgentTest_zip.SetResult(order_id, ContentItem);
	}
}