package test.hbase;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Admin;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.ConnectionFactory;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.client.Result;
import org.apache.hadoop.hbase.client.ResultScanner;
import org.apache.hadoop.hbase.client.Scan;
import org.zillion.util.log.LogUtil;

public class HBaseTest_scan {
	public static boolean delete_UsePutV = true;

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		Connection connection = ConnectionFactory.createConnection(configuration);
		Admin admin = connection.getAdmin();

		int count = 0;
		TableName tableName = TableName.valueOf("database_1", "zillion_data_originaldata6");
//		TableName tableName = TableName.valueOf("db_public", "zillion_data_originaldata6");
		HTable table = (HTable) connection.getTable(tableName);
		Scan scan = new Scan();
		// scan.addColumn(ByteToObject.toBytes("f"), ByteToObject.toBytes("v"));
		ResultScanner scanner = table.getScanner(scan);
		while (true) {
			Result res = scanner.next();
			if (res == null) {
				break;
			}
			count++;
			if (count % 100000 == 0) {
				LogUtil.warn("" + count);
			}
		}
		scanner.close();
		LogUtil.warn("" + count);

		admin.close();
		connection.close();
	}

}
