package test.redis;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import redis.clients.jedis.Jedis;

public class TestRedisMain {
	static Jedis jedis;

	public static void main(String[] args) {
		// ӱص Redis 
		jedis = new Jedis("192.168.3.222", 6379);
		jedis.auth("foobared");
		System.out.println("ӱص Redis ɹ");
		main_list1(args);
	}

	public static void main1(String[] args) {
		//  redis ַ
		jedis.set("souvc", "http://www.cnblogs.com/liuhongfeng/");
		// ȡ洢ݲ
		System.out.println("redis洢ַ: " + jedis.get("souvc"));
	}

	public static void main_list1(String[] args) {
		System.out.println("ӱص Redis ɹ");

		// 洢ݵб
		jedis.lpush("kecheng", "java");
		jedis.lpush("kecheng", "php");
		jedis.lpush("kecheng", "Mysql");

		// ȡ洢ݲ
		List<String> list = jedis.lrange("kecheng", 0, 5);
		for (int i = 0; i < list.size(); i++) {
			System.out.println("redis list洢ֵ:" + list.get(i));
		}

	}

	public static void main_list2(String[] args) {
		// ʼǰƳе
		jedis.del("java framework");
		System.out.println(jedis.lrange("java framework", 0, -1));

		// key java frameworkд
		jedis.lpush("java framework", "spring");
		jedis.lpush("java framework", "struts");
		jedis.lpush("java framework", "hibernate");

		// ȡjedis.lrangeǰΧȡ
		// һkeyڶʼλãǽλãjedis.llenȡ -1ʾȡ
		System.out.println(jedis.lrange("java framework", 0, -1));

		jedis.del("java framework");
		jedis.rpush("java framework", "spring");
		jedis.rpush("java framework", "struts");
		jedis.rpush("java framework", "hibernate");
		System.out.println(jedis.lrange("java framework", 0, -1));
	}

	public static void main_map(String[] args) {
		// ---------------
		Map<String, String> map = new HashMap<String, String>();
		map.put("name", "xinxin");
		map.put("age", "22");
		map.put("qq", "123456");

		jedis.hmset("user", map);
		// ȡuserеnameִн:[minxr]-->עһ͵List
		// һǴredismapkeyǷmapеĶkeykeyԸǿɱ
		List<String> rsmap = jedis.hmget("user", "name", "age", "qq");
		System.out.println(rsmap);

		// ɾmapеĳֵ
		jedis.hdel("user", "age");
		System.out.println(jedis.hmget("user", "age")); // ΪɾˣԷصnull
		System.out.println(jedis.hlen("user")); // keyΪuserļдŵֵĸ2
		System.out.println(jedis.exists("user"));// ǷkeyΪuserļ¼ true
		System.out.println(jedis.hkeys("user"));// mapеkey
		System.out.println(jedis.hvals("user"));// mapеvalue

		Iterator<String> iter = jedis.hkeys("user").iterator();
		while (iter.hasNext()) {
			String key = iter.next();
			System.out.println(key + ":" + jedis.hmget("user", key));
		}
	}

	public static void main_set(String[] args) {
		jedis.sadd("users", "liuling");
		jedis.sadd("users", "xinxin");
		jedis.sadd("users", "ling");
		jedis.sadd("users", "zhangxinxin");
		jedis.sadd("users", "who");

		// Ƴnoname
		jedis.srem("users", "who");
		System.out.println(jedis.smembers("users"));// ȡмvalue
		System.out.println(jedis.sismember("users", "who"));// ж who ǷuserϵԪ
		System.out.println(jedis.srandmember("users"));
		System.out.println(jedis.scard("users"));// ؼϵԪظ
	}
}
