package test.redis;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import org.redisson.Redisson;
import org.redisson.api.RLock;
import org.redisson.api.RedissonClient;
import org.redisson.config.Config;
import org.zillion.util.log.LogUtil;

public class TestRedissonMain {
	static RedissonClient redisson;

	public static void main(String[] args) throws Exception {
		Config config = new Config();
		config.useSingleServer().setAddress("redis://192.168.3.222:6379").setPassword("foobared");
		// config.useClusterServers().addNodeAddress("redis://192.168.3.222:6379").setPassword("foobared");
		redisson = Redisson.create(config);

		for (int i = 0; i < Integer.MAX_VALUE; i++) {
			Thread.sleep(1000L);

			main1(args);
		}
		// main_thread(args);

		redisson.shutdown();
	}

	public static void main1(String[] args) throws Exception {
		String[] gg = { "0100018000000000000001016100", "01FF018000000000000001016100" };
		for (String g : gg) {
			RLock lock = redisson.getLock("ZKLockNode:db_test:table_strong_consistency_es:" + g);
			boolean res = lock.tryLock(0, 3, TimeUnit.SECONDS);
			if (res) {
				try {
					LogUtil.warn(g + "\t" + "myjob");
				} finally {
					lock.unlock();
				}
			}
		}
		// {
		// RLock lock = redisson.getLock("anyLock");
		// // RLock lock = redisson.getFairLock("anyLock");
		// lock.lock(10, TimeUnit.SECONDS);
		// }
		// {
		// RLock lock = redisson.getLock("anyLock");
		// LogUtil.warn("1" + "\t" + "1");
		// // boolean res = lock.tryLock();
		// boolean res = lock.tryLock(10, 100, TimeUnit.SECONDS);
		// LogUtil.warn("1" + "\t" + "2");
		// if (res) {
		// try {
		// LogUtil.warn("1" + "\t" + "myjob");
		// } finally {
		// LogUtil.warn("1" + "\t" + "3");
		// lock.unlock();
		// LogUtil.warn("1" + "\t" + "4");
		// }
		// }
		// }
		// {
		// RLock lock = redisson.getLock("anyLock");
		// Future<Boolean> res = lock.tryLockAsync(100, 10, TimeUnit.SECONDS);
		// }
		// {
		// RLock lock1 = redisson.getLock("lock1");
		// RLock lock2 = redisson.getLock("lock2");
		// RLock lock3 = redisson.getLock("lock3");
		// RedissonMultiLock lock = new RedissonMultiLock(lock1, lock2, lock3);
		// boolean res = lock.tryLock(10, 100, TimeUnit.SECONDS);
		// }
	}

	public static void main_thread(String[] args) throws Exception {
		List<TestRedissonThread> threadList = new ArrayList<TestRedissonThread>();
		for (int i = 0; i < 3; i++) {
			TestRedissonThread thread = new TestRedissonThread(redisson, i + 1);
			thread.start();
			threadList.add(thread);
		}

		while (true) {
			Thread.sleep(1000L);

			boolean all_finish = true;
			for (Thread thread : threadList) {
				if (thread.isAlive()) {
					all_finish = false;
					break;
				}
			}
			if (all_finish) {
				break;
			}
		}
	}
}
