package test.zookeeperACL;

import java.util.ArrayList;
import java.util.List;

import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.ZooDefs.Ids;
import org.apache.zookeeper.ZooKeeper;
import org.apache.zookeeper.data.ACL;

public class ACLCreateTest {
	// zk-jaas.confkeyTabʹLinuxбܣ򱨴
	public static void main(String[] args) throws Exception {
		// System.setProperty("zookeeper.authProvider.1", "org.apache.zookeeper.server.auth.SASLAuthenticationProvider");
		// System.setProperty("zookeeper.sasl.clientconfig", "Client");
		System.setProperty("java.security.auth.login.config", "D:/Test/zk-jaas.conf");
		System.setProperty("java.security.krb5.conf", "C:/ProgramData/MIT/Kerberos5/krb5.ini");

		ZooKeeper zk = new ZooKeeper("zookeeper1:2181", 10000, null);
		// zk.addAuthInfo("digest", "admin:admin123".getBytes());

		List<ACL> ACLList = new ArrayList<ACL>();
		// ACLList.add(new ACL(ZooDefs.Perms.ALL, new Id("digest", DigestAuthenticationProvider.generateDigest("admin:admin123"))));
		// ACLList.add(new ACL(ZooDefs.Perms.ALL, new Id("sasl", "hadoop")));
		ACLList = Ids.CREATOR_ALL_ACL;

		String root = "/root";
		System.out.println("create:" + zk.create(root, "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));

		System.out.println("create:" + zk.create(root + "/son1", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son2", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son3", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son1/grandson11", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son1/grandson12", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son1/grandson13", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son2/grandson21", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son2/grandson22", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son2/grandson23", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son3/grandson31", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son3/grandson32", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create(root + "/son3/grandson33", "testData".getBytes("UTF-8"), ACLList, CreateMode.PERSISTENT));

		zk.close();
	}
}
