package useful;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zillion.util.log.LogUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class database_delete {

	public static void main(String[] args) throws Exception{
		Configuration configuration = HBaseConfiguration.create();
		ZillionAgent agent = new ZillionAgent(configuration, "abc");

		try {
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace(); 
		} 

		String database_name = "db_test";

		JSONObject queryJSON=new JSONObject();
		queryJSON.put("QueryType", "table_list_strict");
		queryJSON.put("Database",database_name);
		JSONObject queryResult=agent.Query(queryJSON);
		JSONArray queryContent=(JSONArray)queryResult.get("Content");
		for(int i=0;i<queryContent.size();i++){
			String table_name=(String)queryContent.get(i);
			JSONObject queryJSONInner=new JSONObject();
			queryJSONInner.put("QueryType", "table_drop");
			queryJSONInner.put("Database",database_name);
			queryJSONInner.put("Datatable", table_name);
			JSONObject queryResultInner=agent.Query(queryJSONInner);
			LogUtil.warn(queryResultInner.toJSONString());
		}
		
		agent.NDL_DropDatabase(database_name);
		
		agent.Stop();
	}
}
