package com.zillion.database.agent;

import com.zillion.util.common.HashObject;
import com.zillion.util.table.SchemaWrapper;
import com.zillion.util.table.ZillionTableIndex;
import com.zillion.util.table.ZillionTableSchema;

public class ZillionHashWorkerItem {
	public SchemaWrapper schemaWrapper;
	public boolean finish = false;
	public HashObject hash = null;
	public ZillionTableSchema schema;
	public ZillionTableIndex schema_index;

	ZillionHashWorkerItem(SchemaWrapper schemaWrapper, ZillionTableSchema schema) {
		this.schemaWrapper = schemaWrapper;
		this.schema = schema;
	}

	ZillionHashWorkerItem(SchemaWrapper schemaWrapper, ZillionTableIndex schema_index) {
		this.schemaWrapper = schemaWrapper;
		this.schema_index = schema_index;
	}
}
