package com.zillion.database.async;

import java.util.Date;

import com.alibaba.fastjson.JSONObject;

public class AsyncJob {
	String uuid;
	public boolean finish;
	public JSONObject queryJSON;
	public long count;
	public boolean success;
	public String exception;
	public JSONObject queryResult;
	public Date time_start;
	public Date time_end;
	public AsyncResultSet brs;

	public AsyncJob(String uuid, JSONObject queryJSON) {
		this.uuid = uuid;
		this.queryJSON = queryJSON;
		this.finish = false;
		this.count = 0L;
		this.time_start = new Date();
	}

	public synchronized void Add(long count_add) {
		this.count += count_add;
	}

	public synchronized void Finish(JSONObject queryResult, boolean success, String exception) {
		this.queryResult = queryResult;
		this.success = success;
		this.exception = exception;
		this.time_end = new Date();
		this.finish = true;
	}

	public synchronized boolean IsFinish() {
		return this.finish;
	}
}
