package com.zillion.database.second;

import java.math.BigDecimal;
import java.math.BigInteger;

import org.zillion.util.common.MyException;

public class SecondComparableUtil {

	public static int compare_value(Object obj1, Object obj2) throws Exception {
		if (obj1 == null || obj2 == null) {
			if (obj1 == null && obj2 != null) {
				return -1;
			} else if (obj1 != null && obj2 == null) {
				return 1;
			} else {
				return 0;
			}
		} else {
			if (obj1 instanceof String && obj2 instanceof String) {
				String val1 = (String) obj1;
				String val2 = (String) obj2;
				return val1.compareTo(val2);
			} else if (obj1 instanceof Boolean && obj2 instanceof Boolean) {
				Boolean val1 = (Boolean) obj1;
				Boolean val2 = (Boolean) obj2;
				return val1.compareTo(val2);
			} else if ((obj1 instanceof Integer || obj1 instanceof Long || obj1 instanceof BigInteger)
					&& (obj2 instanceof Integer || obj2 instanceof Long || obj2 instanceof BigInteger)) {
				long val1;
				long val2;
				if (obj1 instanceof Integer) {
					val1 = ((Integer) obj1).longValue();
				} else if (obj1 instanceof Long) {
					val1 = ((Long) obj1).longValue();
				} else {
					val1 = ((BigInteger) obj1).longValue();
				}
				if (obj2 instanceof Integer) {
					val2 = ((Integer) obj2).longValue();
				} else if (obj2 instanceof Long) {
					val2 = ((Long) obj2).longValue();
				} else {
					val2 = ((BigInteger) obj2).longValue();
				}
				if (val1 < val2) {
					return -1;
				} else if (val1 > val2) {
					return 1;
				} else {
					return 0;
				}
			} else if ((obj1 instanceof Integer || obj1 instanceof Long || obj1 instanceof BigInteger || obj1 instanceof Float
					|| obj1 instanceof Double || obj1 instanceof BigDecimal)
					&& (obj2 instanceof Integer || obj2 instanceof Long || obj2 instanceof BigInteger || obj2 instanceof Float
							|| obj2 instanceof Double || obj2 instanceof BigDecimal)) {
				double val1;
				double val2;
				if (obj1 instanceof Integer) {
					val1 = ((Integer) obj1).longValue();
				} else if (obj1 instanceof Long) {
					val1 = ((Long) obj1).longValue();
				} else if (obj1 instanceof BigInteger) {
					val1 = ((BigInteger) obj1).longValue();
				} else if (obj1 instanceof Float) {
					val1 = ((Float) obj1).longValue();
				} else if (obj1 instanceof Double) {
					val1 = ((Double) obj1).longValue();
				} else {
					val1 = ((BigDecimal) obj1).longValue();
				}
				if (obj2 instanceof Integer) {
					val2 = ((Integer) obj2).longValue();
				} else if (obj2 instanceof Long) {
					val2 = ((Long) obj2).longValue();
				} else if (obj2 instanceof BigInteger) {
					val2 = ((BigInteger) obj2).longValue();
				} else if (obj2 instanceof Float) {
					val2 = ((Float) obj2).longValue();
				} else if (obj2 instanceof Double) {
					val2 = ((Double) obj2).longValue();
				} else {
					val2 = ((BigDecimal) obj2).longValue();
				}
				if (val1 < val2) {
					return -1;
				} else if (val1 > val2) {
					return 1;
				} else {
					return 0;
				}
			} else {
				throw new MyException("compare_value error " + obj1.getClass().getName() + " " + obj2.getClass().getName());
			}
		}
	}
}
