package com.zillion.database.second.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.second.ISecondComparable;
import com.zillion.database.second.SecondAnnotation;
import com.zillion.database.second.SecondComparableUtil;

@SecondAnnotation(value = "dao_data")
public class ComparableImpl_in implements ISecondComparable {
	String column;
	JSONArray param;

	public static String Name() {
		return "in";
	}

	public void setColumn(String column) {
		this.column = column;
	}

	public void setParam(Object param) {
		this.param = (JSONArray) param;
	}

	public boolean match(JSONObject jsonObject) throws Exception {
		Object columnValue = jsonObject.get(this.column);
		for (int i = 0; i < param.size(); i++) {
			Object paramItem = param.get(i);
			int cmp = SecondComparableUtil.compare_value(columnValue, paramItem);
			if (cmp == 0) {
				return true;
			}
		}
		return false;
	}
}
