package com.zillion.database.second.impl;

import com.alibaba.fastjson.JSONObject;
import com.zillion.database.second.ISecondComparable;
import com.zillion.database.second.SecondAnnotation;
import com.zillion.database.second.SecondComparableUtil;

@SecondAnnotation(value = "dao_data")
public class ComparableImpl_ne implements ISecondComparable {
	String column;
	Object param;

	public static String Name() {
		return "$ne";
	}

	public void setColumn(String column) {
		this.column = column;
	}

	public void setParam(Object param) {
		this.param = param;
	}

	public boolean match(JSONObject jsonObject) throws Exception {
		Object columnValue = jsonObject.get(this.column);
		int cmp = SecondComparableUtil.compare_value(columnValue, param);
		if (cmp == 0) {
			return !true;
		} else {
			return !false;
		}
	}
}
