package com.zillion.util.common;

import java.util.HashMap;
import java.util.Map;

public class ZillionConstant {
	public static final String zk_root = "/zillion";
	public static final String _ns = "/ns";
	public static final String _nslock = "/nslock";
	public static final String _initbegin = "/initbegin";
	public static final String _initend = "/initend";

	public static final String zk_meta_data = "/meta_data";
	public static final String zk_meta_index = "/meta_index";
	public static final String zk_metalock = "/metalock";
	public static final String zk_tablelocks = "/tablelocks";
	public static final String zk_cachelocks = "/cachelocks";
	public static final String zk_hash_exist = "/hash_exist";
	public static final String zk_hash_tmp = "/hash_tmp";
	public static final String zk_hashlocks = "/hashlocks";
	public static final String zk_observer = "/observer";
	public static final String zk_splitlocks = "/splitlocks";

	public static final String prefix_data = "zillion_data_";
	public static final String prefix_index = "zillion_index_";
	public static final String[] familyNames = { "f" };
	public static final String familyName = "f";

	public static boolean disable_AutoFlush = false;

	public static boolean batch = true;

	public static long table_timeout = 1000L * 30;

	public static long query_group_size = 10000;
	public static long export_batch_size = 100000;
	public static int import_batch_size = 10000;

	public static boolean ObserverCheck = false;
	public static long ObserverWait = 3000L;

	public static int WaitFor_seconds = 5;
	public static int WaitFor_seconds_create_split_table = 300;
	public static int retry_count = 2;

	public static Map<String, Boolean> ReservedNamespaceMap = new HashMap<String, Boolean>();

	static {
		ReservedNamespaceMap.put("default", true);
		ReservedNamespaceMap.put("hbase", true);
		ReservedNamespaceMap.put("information_schema", true);
		ReservedNamespaceMap.put("mysql", true);
		ReservedNamespaceMap.put("performance_schema", true);
		ReservedNamespaceMap.put("sys", true);
	}

	public static boolean printCriteriaGroup = false;

	public static boolean alter_compress_major_compact = false;

	public static boolean check_query = false;

	public static int maxVersions = 1;

	public static long strong_consistency_lock_delete_delay = 1000L;
	public static boolean strong_consistency_cache_redis = false;
	// insert delete update 
	public static boolean random_sleep_enable = false;
	public static int random_sleep_bound = 10;
	public static boolean random_exception_enable = false;
	public static int random_exception_bound = 2;
}
