package org.zillion.util.format;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map;

public class FormatUtil {
	private static Map<String, DecimalFormat> DecimalFormatMap = new HashMap<String, DecimalFormat>();

	public static String double2String(String format, Double number) {
		if (!DecimalFormatMap.containsKey(format)) {
			DecimalFormatMap.put(format, new DecimalFormat(format));
		}
		return DecimalFormatMap.get(format).format(number);
	}

	public static String int2String(String format, Integer number) {
		if (!DecimalFormatMap.containsKey(format)) {
			DecimalFormatMap.put(format, new DecimalFormat(format));
		}
		return DecimalFormatMap.get(format).format(number);
	}

	public static String long2String(String format, Long number) {
		if (!DecimalFormatMap.containsKey(format)) {
			DecimalFormatMap.put(format, new DecimalFormat(format));
		}
		return DecimalFormatMap.get(format).format(number);
	}

}
