package org.zillion.util.set;

import java.util.ArrayList;
import java.util.List;

public class HashMap<K, V> implements Map<K, V> {

	List<K> keyList = new ArrayList<K>();
	List<V> valueList = new ArrayList<V>();

	public List<K> getKeyList() {
		return keyList;
	}

	public void setKeyList(List<K> keyList) {
		this.keyList = keyList;
	}

	public List<V> getValueList() {
		return valueList;
	}

	public void setValueList(List<V> valueList) {
		this.valueList = valueList;
	}

	public boolean containsKey(Object key) {
		for (int i = 0; i < keyList.size(); i++) {
			Object keyInner = keyList.get(i);
			if (keyInner.equals(key)) {
				return true;
			}
		}
		return false;
	}

	public V get(Object key) {
		for (int i = 0; i < keyList.size(); i++) {
			Object keyInner = keyList.get(i);
			if (keyInner.equals(key)) {
				return valueList.get(i);
			}
		}
		return null;
	}

	public V put(K key, V value) {
		this.remove(key);

		keyList.add(key);
		valueList.add(value);
		return value;
	}

	public void clear() {
		this.keyList.clear();
		this.valueList.clear();
	}

	public List<K> keySet() {
		return this.keyList;
	}

	public void remove(K key) {
		for (int i = keyList.size() - 1; i >= 0; i--) {
			Object keyInner = keyList.get(i);
			if (keyInner.equals(key)) {
				this.keyList.remove(i);
				this.valueList.remove(i);
			}
		}
	}

	public int size() {
		return this.keyList.size();
	}
}
