import org.apache.hadoop.conf.Configuration;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class AgentTest_delete {

	public static void main(String[] args) throws Exception {
		// Configuration configuration = HBaseConfiguration.create();
		Configuration configuration = new Configuration();
		configuration.set("hbase.cluster.distributed", "true");
		configuration.set("hbase.zookeeper.quorum", "zookeeper1");
		ZillionAgent agent = new ZillionAgent(configuration);
		try {
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace();
		}

		String database = "db_public";
		String[] table_names_all = { "ci_instance", "ci_instanceinput", "ci_instanceoutput", "ci_status", "ce_preroundindex", "ce_curround",
				"ce_computelog", "ce_computeinputlog", "ce_computeinputdetail", "ce_computeoutputdetail", "dy_pointlist", "fjd_0_computelog",
				"fjd_0_computedetail", "tenant", "tenant_energy", "tenant_energy_meter", "tenant_energy_price", "tenant_recharge" };
		String[] table_names_compute = { "ce_preroundindex", "ce_curround", "ce_computelog", "ce_computeinputlog", "ce_computeinputdetail",
				"ce_computeoutputdetail", "fjd_0_computelog", "fjd_0_computedetail" };
		for (String table_name : table_names_compute) {
			agent.Query(
					(JSONObject) JSON.parse(
							"{\"QueryType\": \"delete\",\"Database\": \"" + database + "\",\"Datatable\": \"" + table_name + "\",\"Criteria\":{}}"),
					true);
		}

		agent.Stop();
		System.out.println();
	}

}
