import org.apache.hadoop.conf.Configuration;

import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class AgentTest_export {

	public static void main(String[] args) throws Exception {
		// Configuration configuration = HBaseConfiguration.create();
		Configuration configuration = new Configuration();
		configuration.set("hbase.cluster.distributed", "true");
		configuration.set("hbase.zookeeper.quorum", "zookeeper1,zookeeper2,zookeeper3");
		ZillionAgent agent = new ZillionAgent(configuration);
		agent.Start();

		String database_name = "db_time_data";
		String table_name = "original_month";
		JSONObject Criteria = new JSONObject();
		String zip_path = "D:\\Test\\export\\select.zip";
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "export");
		wrapperObject.put("Database", database_name);
		wrapperObject.put("Datatable", table_name);
		wrapperObject.put("Criteria", Criteria);
		wrapperObject.put("ExportZip", zip_path);
		agent.Query(wrapperObject);

		agent.Stop();
		System.out.println();
	}
}
