import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;

import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class AgentTest_resident_memory {

	public static void main(String[] args) throws Exception {
		Configuration configuration = HBaseConfiguration.create();
		ZillionAgent agent = new ZillionAgent(configuration, "abc");

		agent.Start();

		String namespace = "database_1";
		String tableName = "datatable_1";
		String alter_type = "resident_memory";
		JSONObject alter_content = new JSONObject();
		alter_content.put("resident_memory", true);
		agent.DDL_AlterTable(namespace, tableName, alter_type, alter_content);

		agent.Stop();
	}
}
