import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.IZillionAgent;
import com.zillion.database.agent.ZillionAgent;

public class AgentTest_show {

	public static void main(String[] args) throws Exception {
		IZillionAgent agent;
		  Configuration configuration = HBaseConfiguration.create();
		// Configuration configuration = new Configuration();
		// configuration.set("hbase.cluster.distributed", "true");
		// configuration.set("hbase.zookeeper.quorum", "zookeeper1");
		 agent = new ZillionAgent(configuration);
//		agent = new ZillionAgentWebImpl("http://localhost:8888/metadata-web/");
		agent.Start();

		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "database_list");
		JSONObject databases = agent.Query(wrapperObject);
		JSONArray database_array = (JSONArray) databases.get("Content");
		for (int i = 0; i < database_array.size(); i++) {
			String database_name = (String) database_array.get(i);
			wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "table_list");
			wrapperObject.put("Database", database_name);
			JSONObject result = agent.Query(wrapperObject);
			JSONArray array = (JSONArray) result.get("Content");
			for (int ii = 0; ii < array.size(); ii++) {
				String tableName = (String) array.get(ii);
				{
					wrapperObject = new JSONObject();
					wrapperObject.put("QueryType", "table_detail");
					wrapperObject.put("Database", database_name);
					wrapperObject.put("Datatable", tableName);
					JSONObject resultInner = agent.Query(wrapperObject);
					System.out.println(database_name + "\t" + tableName + ":\n" + FastJsonUtil.toFormatString(resultInner));
				}
				{
					wrapperObject = new JSONObject();
					wrapperObject.put("QueryType", "table_count");
					wrapperObject.put("Database", database_name);
					wrapperObject.put("Datatable", tableName);
					JSONObject resultInner = agent.Query(wrapperObject);
					System.out.println(database_name + "\t" + tableName + ":\n" + FastJsonUtil.toFormatString(resultInner));
				}
			}
		}

		agent.Stop();
		System.out.println();
	}

}
