
import org.zillion.util.common.HexToByte;

import com.zillion.util.common.ByteToObject;

public class ByteToObjectTest {

	public static void main(String[] args) {

		for (float i = (float) 1.0; i > 0.000001; i = (float) (i / 2.0)) {
			byte[] curr = ByteToObject.toBytes(i);
			System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toFloat(curr));
		}
		for (float i = (float) -1.0; i < -0.000001; i = (float) (i / 2.0)) {
			byte[] curr = ByteToObject.toBytes(i);
			System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toFloat(curr));
		}
		for (double i = 1.0; i < 256.0; i = i * 2.0) {
			byte[] curr = ByteToObject.toBytes(i);
			System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toDouble(curr));
		}
		for (double i = -1.0; i > -256.0; i = i * 2.0) {
			byte[] curr = ByteToObject.toBytes(i);
			System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toDouble(curr));
		}
		for (double i = 1.0; i < 256.0; i = i * 1.1) {
			byte[] curr = ByteToObject.toBytes(i);
			System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toDouble(curr));
		}
		for (double i = -1.0; i > -256.0; i = i * 1.1) {
			byte[] curr = ByteToObject.toBytes(i);
			System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toDouble(curr));
		}

		{
			int start = Integer.MIN_VALUE;
			for (int i = start; i < start + 11; i++) {
				byte[] curr = ByteToObject.toBytes(i);
				System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toInt(curr));
			}
		}
		{
			int start = 0 - 4;
			for (int i = start; i < start + 11; i++) {
				byte[] curr = ByteToObject.toBytes(i);
				System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toInt(curr));
			}
		}
		{
			long start = Long.MIN_VALUE;
			for (long i = start + 1; i < start + 11; i++) {
				byte[] curr = ByteToObject.toBytes(i);
				System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toLong(curr));
			}
		}
		{
			long start = 0 - 4;
			for (long i = start + 1; i < start + 11; i++) {
				byte[] curr = ByteToObject.toBytes(i);
				System.out.println("" + i + "\t" + HexToByte.byteToHex(curr) + "\t" + ByteToObject.toLong(curr));
			}
		}

	}

}
