import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class TestBig2 {

	public static void main(String[] args) {
		for (int i = 1;; i++) {
			BBBBBB b = divide(BigInteger.valueOf(81), BigInteger.valueOf(i));
			String ss = b.toString2();
			if (ss.contains("2018")) {
				System.out.println(i + "\t" + b.toString());
				System.out.println(b.toString2());
				break;
			}
		}
	}

	public static BBBBBB divide(BigInteger x, BigInteger y) {
		List<BigInteger> yushuList = new ArrayList<BigInteger>();

		BBBBBB result = new BBBBBB();
		result.zheng = x.divide(y).intValue();
		BigInteger tmp = x.remainder(y);
		while (true) {
			tmp = tmp.multiply(BigInteger.valueOf(10));
			BigInteger t1 = tmp.divide(y);
			BigInteger t2 = tmp.remainder(y);
			for (int i = 0; i < yushuList.size(); i++) {
				BigInteger yushu = yushuList.get(i);
				if (t2.equals(yushu)) {
					result.index = i;
					break;
				}
			}
			if (result.index != -1) {
				break;
			}
			result.xiaoshuList.add(t1.intValue());
			yushuList.add(t2);

			tmp = t2;

			if (tmp.equals(0)) {
				break;
			}
		}
		return result;
	}

}

class BBBBBB {
	public int zheng;
	List<Integer> xiaoshuList = new ArrayList<Integer>();
	int index = -1;

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(zheng);
		sb.append(".");
		if (index == -1) {
			for (int i = 0; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
		} else {
			for (int i = 0; i < index; i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
			sb.append("(");
			for (int i = index; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
			sb.append(")");
		}
		return sb.toString();
	}

	public String toString2() {
		StringBuffer sb = new StringBuffer();
		sb.append(zheng);
		sb.append(".");
		if (index == -1) {
			for (int i = 0; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
		} else {
			for (int i = 0; i < index; i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
			for (int i = index; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
			for (int i = index; i < xiaoshuList.size(); i++) {
				int xiaoshu = xiaoshuList.get(i);
				sb.append(xiaoshu);
			}
		}
		return sb.toString();
	}
}