package jdbc;

import java.sql.Connection;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.zillion.database.util.MySQLUtil;
import com.zillion.database.util.ResultSet_MySQL;

public class MySQLTest {
	static {
		try {
			Class.forName("com.mysql.jdbc.Driver").newInstance();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws Exception {
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306", "pbsage", "123456");
		List<Integer> typeList = new ArrayList<Integer>();
		List<Object> params = new ArrayList<Object>();
		String stringSQL_MyISAM = "select * from database_1.zillion_data_datatable_1";
		String stringSQL_MEMORY = "select * from public.database_1_zillion_data_datatable_1";
		long time_MyISAM = 0L;
		long time_MEMORY = 0L;
		for (int i = 0; i < 100; i++) {
			Date time1 = new Date();
			ResultSet_MySQL result_MyISAM = MySQLUtil.ori_select(conn, stringSQL_MyISAM, typeList, params);
			Date time2 = new Date();
			ResultSet_MySQL result_MEMORY = MySQLUtil.ori_select(conn, stringSQL_MEMORY, typeList, params);
			Date time3 = new Date();
			time_MyISAM += time2.getTime() - time1.getTime();
			time_MEMORY += time3.getTime() - time2.getTime();
		}
		System.out.println(time_MyISAM + "\t\t" + time_MEMORY);
		conn.close();
	}

}
