package regionTest;

import org.apache.hadoop.conf.Configuration;

import com.zillion.database.agent.ZillionAgent;

public class ZillionMulti {

	public static ZillionAgent Get() {
		ZillionAgent agent = null;
		try {
			// Configuration configuration = HBaseConfiguration.create();
			Configuration configuration = new Configuration();
			configuration.set("hbase.cluster.distributed", "true");
			configuration.set("hbase.zookeeper.quorum", "zookeeper1,zookeeper2,zookeeper3");
			agent = new ZillionAgent(configuration, "RegionTest");
			agent.Start();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return agent;
	}
}
