package test.compress;

import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class Thread_zip_insert extends Thread {
	ZillionAgent agent;
	String Database;
	String Datatable;

	public Thread_zip_insert(ZillionAgent agent, String Database, String Datatable) {
		this.agent = agent;
		this.Database = Database;
		this.Datatable = Datatable;
	}

	public void run() {
		while (true) {
			JSONObject job = AgentTest_zip.Pop_insert_update();
			if (job == null) {
				break;
			}

			try {
				Process(job);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	void Process(JSONObject job) throws Exception {
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "insert");
		wrapperObject.put("Database", Database);
		wrapperObject.put("Datatable", Datatable);
		wrapperObject.put("InsertObject", job);
		agent.Query(wrapperObject);
	}
}