package test.compress;

import com.alibaba.fastjson.JSONObject;
import com.zillion.database.agent.ZillionAgent;

public class Thread_zip_update extends Thread {
	ZillionAgent agent;
	String Database;
	String Datatable;

	public Thread_zip_update(ZillionAgent agent, String Database, String Datatable) {
		this.agent = agent;
		this.Database = Database;
		this.Datatable = Datatable;
	}

	public void run() {
		while (true) {
			JSONObject job = AgentTest_zip.Pop_insert_update();
			if (job == null) {
				break;
			}

			try {
				Process(job);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	void Process(JSONObject job) throws Exception {
		String order_id = (String) job.get("order_id");
		String wo_body = (String) job.get("wo_body");
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "update");
		wrapperObject.put("Database", Database);
		wrapperObject.put("Datatable", Datatable);
		JSONObject Criteria = new JSONObject();
		Criteria.put("order_id", order_id);
		wrapperObject.put("Criteria", Criteria);
		JSONObject Set = new JSONObject();
		Set.put("wo_body", wo_body);
		wrapperObject.put("Set", Set);
		agent.Query(wrapperObject);
	}
}