package test.es;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ESSpeedUtil {
	static DecimalFormat df = new DecimalFormat("0000");
	static SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

	public static List<Object> generate(String propertyName, String type, int count) throws Exception {
		List<Object> result = null;
		if (type.equals("keyword") || type.equals("text")) {
			result = new ArrayList<Object>();
			if (propertyName.equals("postDate")) {
				Date ddd = sdf.parse("20200101000000");
				for (int i = 0; i < count; i++) {
					result.add(sdf.format(new Date(ddd.getTime() + 1000L * i)));
				}
			} else {
				for (int i = 0; i < count; i++) {
					result.add("name" + df.format(i));
				}
			}
		} else if (type.equals("integer")) {
			result = new ArrayList<Object>();
			for (int i = 0; i < count; i++) {
				result.add(i);
			}
		} else if (type.equals("double")) {
			result = new ArrayList<Object>();
			for (int i = 0; i < count; i++) {
				result.add(1.0 * i);
			}
		} else if (type.equals("date")) {
			result = new ArrayList<Object>();
			Date ddd = sdf.parse("20200101000000");
			for (int i = 0; i < count; i++) {
				result.add(new Date(ddd.getTime() + 1000L * i));
			}
		}
		return result;
	}

	public static boolean next(int[] indexes, int count) {
		boolean finish = true;
		for (int i = 0; i < indexes.length; i++) {
			if (indexes[i] != count - 1) {
				finish = false;
				break;
			}
		}
		if (finish) {
			return true;
		}

		for (int i = 0; i < indexes.length; i++) {
			if (indexes[i] == count - 1) {
				indexes[i] = 0;
			} else {
				indexes[i] = indexes[i] + 1;
				break;
			}
		}
		return false;
	}
}
