package test.zookeeper;

import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.ZooDefs.Ids;
import org.apache.zookeeper.ZooKeeper;

public class CreateTest {

	public static void main(String[] args) throws Exception {
		ZooKeeper zk = new ZooKeeper("zookeeper1:2181,zookeeper2:2181,zookeeper3:2181", 10000, null);

		System.out.println("create:" + zk.create("/root", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));

		System.out.println("create:" + zk.create("/root/son1", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son2", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son3", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son1/grandson11", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son1/grandson12", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son1/grandson13", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son2/grandson21", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son2/grandson22", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son2/grandson23", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son3/grandson31", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son3/grandson32", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));
		System.out.println("create:" + zk.create("/root/son3/grandson33", "testData".getBytes("UTF-8"), Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT));

		zk.close();
	}
}
