package test.zookeeperACL;

import java.util.List;

import org.apache.zookeeper.ZooKeeper;
import org.apache.zookeeper.data.Stat;

public class ACLDeleteTest {
	// zk-jaas.confkeyTabʹLinuxбܣ򱨴
	public static void main(String[] args) throws Exception {
		// System.setProperty("zookeeper.authProvider.1", "org.apache.zookeeper.server.auth.SASLAuthenticationProvider");
		// System.setProperty("zookeeper.sasl.clientconfig", "Client");
		System.setProperty("java.security.auth.login.config", "D:/Test/zk-jaas.conf");
		System.setProperty("java.security.krb5.conf", "C:/ProgramData/MIT/Kerberos5/krb5.ini");

		ZooKeeper zk = new ZooKeeper("zookeeper1:2181", 10000, null);
		// zk.addAuthInfo("digest", "admin:admin123".getBytes());

		String root = "/root";
		recursive(zk, root);

		zk.close();
	}

	public static void recursive(ZooKeeper zk, String path) throws Exception {
		Stat stat = zk.exists(path, false);
		if (stat == null) {
			return;
		}

		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}

		zk.delete(path, -1);
		System.out.println("delete:" + path);
	}

	public static void recursiveChildren(ZooKeeper zk, String path) throws Exception {
		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}
	}
}
