package test.zookeeperACL;

import java.util.ArrayList;
import java.util.List;

import org.apache.zookeeper.ZooDefs;
import org.apache.zookeeper.ZooKeeper;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Id;
import org.apache.zookeeper.data.Stat;

public class ACLSetTest {
	// zk-jaas.confkeyTabʹLinuxбܣ򱨴
	public static void main(String[] args) throws Exception {
		// System.setProperty("zookeeper.authProvider.1", "org.apache.zookeeper.server.auth.SASLAuthenticationProvider");
		// System.setProperty("zookeeper.sasl.clientconfig", "Client");
		System.setProperty("java.security.auth.login.config", "D:/Test/zk-jaas.conf");
		System.setProperty("java.security.krb5.conf", "C:/ProgramData/MIT/Kerberos5/krb5.ini");

		ZooKeeper zk = new ZooKeeper("zookeeper1:2181", 10000, null);
		// zk.addAuthInfo("digest", "admin:admin123".getBytes());

		List<ACL> ACLList = new ArrayList<ACL>();
		ACLList.add(new ACL(ZooDefs.Perms.ALL, new Id("sasl", "hadoop")));
		// ACLList.add(new ACL(ZooDefs.Perms.ALL, new Id("digest", DigestAuthenticationProvider.generateDigest("admin:admin123"))));

		String root = "/";
		Stat stat = zk.setACL(root, ACLList, -1);
		System.out.println(stat.toString());

		zk.close();
	}
}
